######################################################################################################
#######################LIBRERIAS A UTILIZAR PARA EL CALCULO DE LOS EE ################################
######################################################################################################

#Esta sintaxis no incluye las estimaciones para las DRE "Madre de Dios", "Moquegua"#
#"Tacna" y "Tumbes" ya que la ECE en dichas DRE se aplica de forma censal.#


install.packages("VIM")
install.packages("gdata")
install.packages("foreign")
install.packages("sampling")
install.packages("survey")
install.packages("xlsx")

library(VIM)
library(gdata)
library(foreign)
library(sampling)
library(survey)
library(xlsx)

######################################################################################################
#################################CARPETA DONDE SE ALMACENAN LAS BASES#################################
######################################################################################################

#Cambiar por la ruta actual de la carpeta. 
setwd("C:/2P Estimación MC")
getwd()


######################################################################################################
########################ESTIMACIÓN DE LA MEDIA Y EL EE DE CADA ESTRATO################################
######################################################################################################



######################################ESTIMACION PARA LECTURA#########################################
######################################################################################################

#----------------------------------------------------------------------------------------------------#
#---------------------------LLAMAR LA BASE DE ESTUDIANTES PARA LECTURA-------------------------------#
#----------------------------------------------------------------------------------------------------#

ECE_2P_alumnos<-read.spss("E. estándar Lectura.sav", use.value.labels = TRUE, to.data.frame = TRUE)
head(ECE_2P_alumnos)
attach(ECE_2P_alumnos)

#---------------------ESTIMACION NIVELES DE LOGRO  Y MEDIDA PROMEDIO----------------------------------#
#######################################################################################################

estimacion<-function(cod_DRE1,Restrato,acumular){
  samplec1<-subset(ECE_2P_alumnos, cod_eva16 == 'MC2016' & Restrato == cod_DRE1  , select = cod_eva16:nom_dre)
  
  #---------------------Estimacion de media SE y Deff-------------------------------------#
  dclus1<-svydesign(ids=~ID_IE,probs =~prob_C ,strata= ~estrato_6,data=samplec1,pps="overton",nest=TRUE,variance = "YG")
  dclus1
  a<-svymean(~grupo_L+M500_L,dclus1)
  
  if(acumular==FALSE){
    m<-cbind(data.frame(cod_DRE1),t(data.frame(a)))
  }else{
    m<-rbind(m,cbind(data.frame(cod_DRE1),t(data.frame(a))))
  }
  m
}


m<-estimacion ("MC2016",cod_eva16,FALSE)

m<-estimacion ("Hombre",sexo,TRUE)
m<-estimacion ("Mujer",sexo,TRUE)

m<-estimacion ("Estatal",Gestion2,TRUE)
m<-estimacion ("No estatal",Gestion2,TRUE)

m<-estimacion ("Urbana",Area,TRUE)
m<-estimacion ("Rural",Area,TRUE)

m<-estimacion ("Polidocente Completo",Caracteristica2,TRUE)
m<-estimacion ("Unidocente / Multigrado",Caracteristica2,TRUE)

m<-estimacion ("0100",cod_DRE,TRUE)
m<-estimacion ("0200",cod_DRE,TRUE)
m<-estimacion ("0300",cod_DRE,TRUE)
m<-estimacion ("0400",cod_DRE,TRUE)
m<-estimacion ("0500",cod_DRE,TRUE)
m<-estimacion ("0600",cod_DRE,TRUE)
m<-estimacion ("0701",cod_DRE,TRUE)
m<-estimacion ("0800",cod_DRE,TRUE)
m<-estimacion ("0900",cod_DRE,TRUE)
m<-estimacion ("1000",cod_DRE,TRUE)
m<-estimacion ("1100",cod_DRE,TRUE)
m<-estimacion ("1200",cod_DRE,TRUE)
m<-estimacion ("1300",cod_DRE,TRUE)
m<-estimacion ("1400",cod_DRE,TRUE)
m<-estimacion ("1501",cod_DRE,TRUE)
m<-estimacion ("1502",cod_DRE,TRUE)
m<-estimacion ("1600",cod_DRE,TRUE)
m<-estimacion ("1900",cod_DRE,TRUE)
m<-estimacion ("2000",cod_DRE,TRUE)
m<-estimacion ("2100",cod_DRE,TRUE)
m<-estimacion ("2200",cod_DRE,TRUE)
m<-estimacion ("2500",cod_DRE,TRUE)



m1<-m[,-1]
m1_1<-cbind.data.frame(m1[,-4]*100,m1[,4])

m1_1
Estratos_Etiqueta<-rep(c("Nacional","Hombre","Mujer","Estatal","No estatal","Urbano","Rural","Polidocente Completo","Unidocente /Multigrado",
                         "Amazonas","Áncash","Apurímac","Arequipa","Ayacucho","Cajamarca","Callao","Cusco","Huancavelica","Huánuco","Ica",
                         "Junín","La Libertad","Lambayeque","Lima Metropolitana","Lima Provincias","Loreto","Pasco",
                         "Piura","Puno","San Martín","Ucayali"),each=2)

m2<-cbind.data.frame(Etiqueta=rep(c("Estimación","Error estándar"),31),Estratos_Etiqueta,m1_1)
rownames(m2)<-NULL
colnames(m2)<-c("Etiquetas","Estratos","En Inicio","En Proceso","Satisfactorio","Medida promedio")
#####write.xlsx(m2, "C:/Users/WHERNANDEZ/Desktop/2P nuevos estratos PPT final/mydata.xlsx")#####
write.xlsx(m2, "Resultados Lectura .xlsx")




######################################ESTIMACION PARA MATEMÁTICA######################################
######################################################################################################

#----------------------------------------------------------------------------------------------------#
#---------------------------LLAMAR LA BASE DE ESTUDIANTES PARA MATEMÁTICA----------------------------#
#----------------------------------------------------------------------------------------------------#
ECE_2P_alumnos<-read.spss("E. estándar Matemática.sav", use.value.labels = TRUE, to.data.frame = TRUE)
head(ECE_2P_alumnos)
attach(ECE_2P_alumnos)



#---------------------ESTIMACION NIVELES DE LOGRO  Y MEDIDA PROMEDIO----------------------------------#
#######################################################################################################

estimacion<-function(cod_DRE1,Restrato,acumular){
  samplec1<-subset(ECE_2P_alumnos, cod_eva16 == 'MC2016' & Restrato == cod_DRE1  , select = cod_eva16:nom_dre)
  
  #---------------------Estimacion de media SE y Deff-------------------------------------#
  dclus1<-svydesign(ids=~ID_IE,probs =~prob_M ,strata= ~estrato_6,data=samplec1,pps="overton",nest=TRUE,variance = "YG")
  dclus1
  a<-svymean(~grupo_M+M500_M,dclus1)
  
  if(acumular==FALSE){
    m<-cbind(data.frame(cod_DRE1),t(data.frame(a)))
  }else{
    m<-rbind(m,cbind(data.frame(cod_DRE1),t(data.frame(a))))
  }
  m
}
m<-estimacion ("MC2016",cod_eva16,FALSE)

m<-estimacion ("Hombre",sexo,TRUE)
m<-estimacion ("Mujer",sexo,TRUE)

m<-estimacion ("Estatal",Gestion2,TRUE)
m<-estimacion ("No estatal",Gestion2,TRUE)

m<-estimacion ("Urbana",Area,TRUE)
m<-estimacion ("Rural",Area,TRUE)

m<-estimacion ("Polidocente Completo",Caracteristica2,TRUE)
m<-estimacion ("Unidocente / Multigrado",Caracteristica2,TRUE)

m<-estimacion ("0100",cod_DRE,TRUE)
m<-estimacion ("0200",cod_DRE,TRUE)
m<-estimacion ("0300",cod_DRE,TRUE)
m<-estimacion ("0400",cod_DRE,TRUE)
m<-estimacion ("0500",cod_DRE,TRUE)
m<-estimacion ("0600",cod_DRE,TRUE)
m<-estimacion ("0701",cod_DRE,TRUE)
m<-estimacion ("0800",cod_DRE,TRUE)
m<-estimacion ("0900",cod_DRE,TRUE)
m<-estimacion ("1000",cod_DRE,TRUE)
m<-estimacion ("1100",cod_DRE,TRUE)
m<-estimacion ("1200",cod_DRE,TRUE)
m<-estimacion ("1300",cod_DRE,TRUE)
m<-estimacion ("1400",cod_DRE,TRUE)
m<-estimacion ("1501",cod_DRE,TRUE)
m<-estimacion ("1502",cod_DRE,TRUE)
m<-estimacion ("1600",cod_DRE,TRUE)
m<-estimacion ("1900",cod_DRE,TRUE)
m<-estimacion ("2000",cod_DRE,TRUE)
m<-estimacion ("2100",cod_DRE,TRUE)
m<-estimacion ("2200",cod_DRE,TRUE)
m<-estimacion ("2500",cod_DRE,TRUE)


m1<-m[,-1]
m1_1<-cbind.data.frame(m1[,-4]*100,m1[,4])

m1_1
Estratos_Etiqueta<-rep(c("Nacional","Hombre","Mujer","Estatal","No estatal","Urbano","Rural","Polidocente Completo","Unidocente /Multigrado",
                         "Amazonas","Áncash","Apurímac","Arequipa","Ayacucho","Cajamarca","Callao","Cusco","Huancavelica","Huánuco","Ica",
                         "Junín","La Libertad","Lambayeque","Lima Metropolitana","Lima Provincias","Loreto","Pasco",
                         "Piura","Puno","San Martín","Ucayali"),each=2)

m2<-cbind.data.frame(Etiqueta=rep(c("Estimación","Error estándar"),31),Estratos_Etiqueta,m1_1)
rownames(m2)<-NULL
colnames(m2)<-c("Etiquetas","Estratos","En Inicio","En Proceso","Satisfactorio","Medida promedio")
m2
write.xlsx(m2, "Resultados Matemática.xlsx")

